#include "CPlayer.h"

// ⺻ 
CPlayer::CPlayer()
{	
	m_nScore = 0;
	m_nTurn = 0;
}

// 
CPlayer::CPlayer(CCard ** card)
{
	m_nTurn = 0;
	m_nScore = 0;
	for (int i = 0; i < CARDCOUNT; i++)
	{
		m_card[i] = card[i];
	}
	/*
	for (int i = 0; i < CARDCOUNT; i++)
	{
		cout << " Player card number : " << m_card[i]->m_card.cardNumber << " / Player card type : " << m_card[i]->m_card.cardType << endl;
	}
	*/
	cout << endl;
}

// Ҹ
CPlayer::~CPlayer()
{

}

//
void CPlayer::cardShuffle()
{
	int swapIdx;
	for (int i = 0; i < CARDCOUNT; i++)
	{
		swapIdx = rand() % (CARDCOUNT - i);
		if (swapIdx <= 0)
			swapIdx = 1;
		cardSwap(&m_card[i], &m_card[swapIdx]);
	}
}

//
void CPlayer::cardPrint(int a_cardCount)
{
	cout << "**********[CARD SHUFFLE]**********" << endl;
	for (int i = 0; i < a_cardCount; i++)
	{
		if (i % 3 == 0)
			cout << endl;
		if(m_card[i]->m_card.cardType == O)
			printf("[%2c / %2d]\t", 'O', m_card[i]->m_card.cardNumber);
		else
			printf("[%2c / %2d]\t", 'X', m_card[i]->m_card.cardNumber);
		//cout << m_card[i]->m_card.cardType << " / " << m_card[i]->m_card.cardNumber << "    ";
	}
	cout << endl;
}

//
void CPlayer::getSixCard()
{
	for (int i = 0; i < SIXCARD; i++)
		m_sixCard[i] = popCardStack();
		// cout << "m_sixCard : " << m_sixCard[i].m_card.cardNumber << endl;

	cout << "success get six card" << endl;
}

//
void CPlayer::showCard(CCard * a_pCard, int a_nCardCount)
{
	for (int i = 0; i < a_nCardCount; i++)
	{
		if (i % 3 == 0)
			cout << endl;

		if (a_pCard[i].m_card.cardType == O)
			printf("[%2c / %2d]\t", 'O', a_pCard[i].m_card.cardNumber);
		else
			printf("[%2c / %2d]\t", 'X', a_pCard[i].m_card.cardNumber);
	}
}

// 
void CPlayer::pushCardStack()
{
	cout << endl;
	for (int i = 0; i < CARDCOUNT; i++)
	{
		cout << "[" << i + 1 << "]:";
		m_Stack.push(m_card[i]);
	}
	cout << "card push to stack success" << endl;
}

// 
CCard CPlayer::popCardStack()
{
	return m_Stack.pop();
}

// 
int CPlayer::getScore()
{
	return m_nScore;
}

// 
void CPlayer::putCardGrid()
{

}

//
void CPlayer::cardSwap(CCard ** a_pCardOne, CCard ** a_pCardTwo)
{
	CCard  * temp;
	temp = * a_pCardOne;
	* a_pCardOne = * a_pCardTwo;
	* a_pCardTwo = temp;
}

