#pragma once

#include "Common.h"
#include "CCard.h"
#include "CDeck.h"


class CPlayer
{
public:
	CPlayer();
	CPlayer(CCard **);
	~CPlayer();
	
	CCard m_sixCard[SIXCARD];
	int m_nTurn;

	void cardShuffle();
	void cardPrint(int );
	void getSixCard();
	void pushCardStack();
	CCard popCardStack();
	int getScore();
	void putCardGrid();
	void cardSwap(CCard **, CCard **);
	void showCard(CCard *, int);

private:
	int m_nScore;
	CDeck<CCard * > m_Stack;
	CCard * m_card[CARDCOUNT];
};