#include "Common.h"
#include "CCardGameManager.h"
#include "CCardGameWorld.h"
#include "CPlayer.h"

#define SYS 0

#define CRTDBG_MAP_ALLOC 
#include <stdlib.h> 
#include <crtdbg.h>

#ifdef _DEBUG
#define new new( _NORMAL_BLOCK, __FILE__, __LINE__ )   // #include <new.h> operator new malloc 
                                                                                       // Derivedؼ   ,    .
#endif


int main(int argc, char * argv[])
{

//http://egohim.blog.me/70074738205
string outputMemoryLeaks = "Memory Leak? " 
  + std::to_string(static_cast<LONGLONG>(_CrtDumpMemoryLeaks()));
cout << outputMemoryLeaks.c_str() << endl;

     _CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );

 //_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
 _CrtSetBreakAlloc( 160 );



	srand((unsigned int)time(NULL));

	// ī Ŵ Ŭ
	CCardGameManager gameManager;

	// ü
	Card oCardMember[CARDCOUNT];
	Card xCardMember[CARDCOUNT];
	
	// Ŭ
	CCard * oCard[CARDCOUNT];
	CCard * xCard[CARDCOUNT];


	int i = 0;
	for (i = 0; i < CARDCOUNT; i++)
	{
		oCard[i] = NULL;
		xCard[i] = NULL;
	}

	// o ī 
	gameManager.setOcardMemberInit(oCardMember);
	// cout << "after set ocard member init" << endl << endl;

#if 0
	/*
	for (int i = 0; i < CARDCOUNT; i++)
	{
		cout << "oCard Number:" << oCardMember[i].cardNumber << " / card type: " << oCardMember[i].cardType << endl;
	}
	*/
#endif

	gameManager.setCard(oCard, oCardMember);

	// x ī 
	gameManager.setXcardMemberInit(xCardMember);
	// cout << "after set xcard member init" << endl << endl;

#if 0
	for (int i = 0; i < CARDCOUNT; i++)
	{
		cout << "xCard Number:" << xCardMember[i].cardNumber << " / card type: " << xCardMember[i].cardType << endl;
	}
#endif

	gameManager.setCard(xCard, xCardMember);

#if SYS
	system("cls");
#endif

	// ÷̾ 2 
	CPlayer playerOne(oCard);
	CPlayer playerTwo(xCard);

	//   ü 
	CCardGameWorld cardGameWorld;
	cardGameWorld.cardGameRun(playerOne, playerTwo);

#if 0
	/*
	for (i = 0; i < CARDCOUNT; i++)
	{
		delete oCard[i];
		delete xCard[i];
	}
	*/
#endif

}
